# This file automatically generated by skymarshal
# DO NOT MODIFY BY HAND
# fmt: off
# isort: off
# mypy: disallow-untyped-defs

import copy
import typing as T  # pylint: disable=unused-import

from io import BytesIO
import struct

class optimizer_gnc_params_t(object):
    __slots__ = ["gnc_update_min_reduction", "mu_initial", "mu_step", "mu_max"]  # type: T.List[str]

    def __init__(
        self,
        gnc_update_min_reduction=0.0,  # type: float
        mu_initial=0.0,  # type: float
        mu_step=0.0,  # type: float
        mu_max=0.0,  # type: float
        _skip_initialize=False,  # type: bool
    ):
        # type: (...) -> None
        """ If _skip_initialize is True, all other constructor arguments are ignored """
        if _skip_initialize:
            return
        # The convexity param is stepped each time we early-exit with this threshold.
        self.gnc_update_min_reduction = gnc_update_min_reduction
        # Initial mu value.
        self.mu_initial = mu_initial
        # Amount to change mu each step.
        self.mu_step = mu_step
        # Maximum mu value.
        self.mu_max = mu_max

    @staticmethod
    def _skytype_meta():
        # type: () -> T.Dict[str, str]
        return dict(
            type="struct",
            package="sym",
            name="optimizer_gnc_params_t",
        )

    @classmethod
    def _default(cls):
        # type: () -> optimizer_gnc_params_t
        return cls()

    def __repr__(self):
        # type: () -> str
        return "optimizer_gnc_params_t({})".format(
            ", ".join("{}={}".format(name, repr(getattr(self, name))) for name in self.__slots__))

    def __eq__(self, other):
        # type: (object) -> bool
        if not isinstance(other, optimizer_gnc_params_t):
            return NotImplemented
        return (
            (self.gnc_update_min_reduction==other.gnc_update_min_reduction) and
            (self.mu_initial==other.mu_initial) and
            (self.mu_step==other.mu_step) and
            (self.mu_max==other.mu_max)
        )
    # Disallow hashing for python struct lcmtypes.
    __hash__ = None  # type: ignore

    def encode(self):
        # type: () -> bytes
        buf = BytesIO()
        buf.write(optimizer_gnc_params_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        # type: (T.BinaryIO) -> None
        buf.write(optimizer_gnc_params_t._CACHED_STRUCT_0.pack(self.gnc_update_min_reduction, self.mu_initial, self.mu_step, self.mu_max))

    @staticmethod
    def decode(data):
        # type: (T.Union[bytes, T.BinaryIO]) -> optimizer_gnc_params_t
        # NOTE(eric): This function can technically accept either a BinaryIO or
        # anything that supports the C++ Buffer Protocol,
        # which is unspecifiable in type hints.

        if hasattr(data, "read"):
            # NOTE(eric): mypy isn't able to figure out the hasattr check
            buf = T.cast(T.BinaryIO, data)
        else:
            buf = BytesIO(T.cast(bytes, data))

        if buf.read(8) != optimizer_gnc_params_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return optimizer_gnc_params_t._decode_one(buf)

    @staticmethod
    def _decode_one(buf):
        # type: (T.BinaryIO) -> optimizer_gnc_params_t
        self = optimizer_gnc_params_t(_skip_initialize=True)
        self.gnc_update_min_reduction, self.mu_initial, self.mu_step, self.mu_max = optimizer_gnc_params_t._CACHED_STRUCT_0.unpack(buf.read(16))
        return self

    @staticmethod
    def _get_hash_recursive(parents):
        # type: (T.List[T.Type]) -> int
        if optimizer_gnc_params_t in parents: return 0
        tmphash = (0xdd7ac94886a02102) & 0xffffffffffffffff
        tmphash = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash

    _packed_fingerprint = None  # type: T.Optional[bytes]

    @staticmethod
    def _get_packed_fingerprint():
        # type: () -> bytes
        if optimizer_gnc_params_t._packed_fingerprint is None:
            optimizer_gnc_params_t._packed_fingerprint = struct.pack(">Q", optimizer_gnc_params_t._get_hash_recursive([]))
        return optimizer_gnc_params_t._packed_fingerprint

    def deepcopy(self, **kwargs):
        # type: (**T.Any) -> optimizer_gnc_params_t
        """
        Deep copy of this LCM type

        Returns a copy w/ members specified by kwargs replaced with new values specified by kwargs.
        """
        result = copy.deepcopy(self)
        for key in kwargs:
            if not hasattr(result, key):
                raise KeyError("Type optimizer_gnc_params_t does not have attribute: " + str(key))
            setattr(result, key, kwargs[key])
        return result

    _CACHED_STRUCT_0 = struct.Struct(">ffff")
